/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.ldt.mall.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.common.constant.SystemConstant;
import org.springblade.core.launch.constant.AppConstant;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.ldt.appaccount.entity.AppAccount;
import org.springblade.modules.ldt.appaccount.service.IAppAccountService;
import org.springblade.modules.ldt.channel.entity.PointChannel;
import org.springblade.modules.ldt.channel.service.IPointChannelService;
import org.springblade.modules.ldt.pointdetail.entity.PointDetail;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.ldt.mall.entity.Mall;
import org.springblade.modules.ldt.mall.vo.MallVO;
import org.springblade.modules.ldt.mall.service.IMallService;
import org.springblade.core.boot.ctrl.BladeController;

import java.math.BigDecimal;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-07-28
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-ldt/mall")
@Api(value = "", tags = "接口")
public class MallController extends BladeController {

	private final IMallService mallService;
	private final IPointChannelService pointChannelService;
	private final IAppAccountService appAccountService;
	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入mall")
	public R<Mall> detail(Mall mall) {
		Mall detail = mallService.getOne(Condition.getQueryWrapper(mall));
		return R.data(detail);
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入mall")
	public R<IPage<Mall>> list(@RequestParam Map<String,Object> mall, Query query) {
		IPage<Mall> pages = mallService.page(Condition.getPage(query), Condition.getQueryWrapper(mall,Mall.class));
		return R.data(pages);
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入mall")
	public R<IPage<MallVO>> page(MallVO mall, Query query) {
		IPage<MallVO> pages = mallService.selectMallPage(Condition.getPage(query), mall);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入mall")
	public R save(@Valid @RequestBody Mall mall) {
		return R.status(mallService.save(mall));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入mall")
	public R update(@Valid @RequestBody Mall mall) {
		return R.status(mallService.updateById(mall));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入mall")
	@Transactional
	public R submit(@Valid @RequestBody Mall mall) {
		Assert.notNull(mall.getPersonTel(),"商场关联的手机号不能为空");
		//新增商场时同时新增渠道
		if(mall.getId() != null){//编辑
			return R.status(mallService.updateById(mall));
		}else{//新增
			PointChannel pointChannel = new PointChannel();
			pointChannel.setDiscount(BigDecimal.valueOf(100));
			pointChannel.setLogo(mall.getPic());
			pointChannel.setName(mall.getName());
			pointChannel.setPointValue(BigDecimal.ZERO);
			pointChannel.setType(SystemConstant.PointChannelType.MALL.getValue());
			pointChannel.setSort(1);
			if(mallService.save(mall)){
				pointChannel.setRelationId(mall.getId());
				pointChannel.setPaymentDays(mall.getPaymentDays());
				return R.status(pointChannelService.save(pointChannel));
			}

			//判断该手机号是否已经有账号存在
//			AppAccount appAccount = appAccountService.getBaseMapper().selectOne(new QueryWrapper<>(new AppAccount())
//				.lambda().eq(AppAccount::getPhone,));

			return R.status(false);
		}

	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(mallService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 删除
	 */
	@PostMapping("/pageWithActivityCount")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R<IPage<MallVO>> pageWithActivityCount(MallVO mallVO,Query query) {
		IPage<MallVO> page = mallService.pageWithActivityCount(Condition.getPage(query),mallVO);
		return R.data(page);
	}


}
